/*	SystemInfo 1.0
 *
 *	Filename:	 system_info.cpp
 *	Description: SystemInfo :)
 *
 *	Copyright (c) 1999, Brian Luft (bluft@execpc.com)
 */

//------------- Global Constants -------------//
#define SI_OK_CLICKED 'SIok'

//------------- SIView -------------//
#include <StringView.h>
#include <View.h>
#include <Button.h>

class SIView:public BView
{
public:
	// Constructor
	SIView(void);
	// Destructor
	~SIView(void);
	
	void GetSystemInformation(void);
	
private:
	BStringView *info1;
	BStringView *info2;
	BStringView *info3;
	BStringView *info4;
	BStringView *info5;
	BStringView *info6;
	BStringView *info7;
	BStringView *info8;
	BStringView *info9;
	BStringView *info10;
	BButton *button;
};

//------------- SIView Constructor -------------//
SIView::SIView(void):
	BView(
		/* BRect frame */ BRect(0.0, 0.0, 300.0, 200.0),
		/* const char *name */ "bg",
		/* uint32 resizingMode */ B_FOLLOW_NONE,
		/* uint32 flags */ B_WILL_DRAW)
{
	// Paint it "Be Grey"
	SetViewColor(219, 219, 219);
	// Initialize the BStringView and BButton
	button = new BButton(
		/* BRect frame */ BRect(255.0, 155.0, 295.0, 195.0),
		/* const char *name */ "ok",
		/* const char *label */ "OK",
		/* BMessage *message */	new BMessage(SI_OK_CLICKED));
	button->MakeDefault(true);
	AddChild(button);
	BRect rect1 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 1));
	BRect rect2 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 2));
	BRect rect3 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 3));
	BRect rect4 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 4));
	BRect rect5 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 5));
	BRect rect6 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 6));
	BRect rect7 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 7));
	BRect rect8 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 8));
	BRect rect9 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 9));
	BRect rect10 = BRect(5.0, 5.0, 295.0, 5 + ((195.0 / 11.0) * 10));
	
	info1 = new BStringView(rect1, "info1", "info 1");
	AddChild(info1);
	info2 = new BStringView(rect2, "info2", "info 2");
	AddChild(info2);
	info3 = new BStringView(rect3, "info3", "info 3");
	AddChild(info3);
	info4 = new BStringView(rect4, "info4", "info 4");
	AddChild(info4);
	info5 = new BStringView(rect5, "info5", "info 5");
	AddChild(info5);
	info6 = new BStringView(rect6, "info6", "info 6");
	AddChild(info6);
	info7 = new BStringView(rect7, "info7", "info 7");
	AddChild(info7);
	info8 = new BStringView(rect8, "info8", "info 8");
	AddChild(info8);
	info9 = new BStringView(rect9, "info9", "info 9");
	AddChild(info9);
	info10 = new BStringView(rect10, "info10", "info 10");
	AddChild(info10);
	
	GetSystemInformation();
};

//------------- SIView Destructor -------------//
SIView::~SIView(void)
{
	// Do nothing
};

//------------- SIView::GetSystemInformation -------------//
#include <OS.h>
#include <stdio.h>

void SIView::GetSystemInformation(void)
{
	// Is the computer on?
	int32 intIsComputerOn = is_computer_on();
	char *IsComputerOn = (intIsComputerOn == 1) ? "Your computer is on" : "Your computer is off";
	// Is the computer on fire?
	double dblIsComputerOnFire = is_computer_on_fire();
	char *IsComputerOnFire = (dblIsComputerOnFire != 0) ? "Your computer is not on fire" : "Your computer is on fire.  Get a fire extinguisher.";
	// How long has the computer been booted? 
	int32 Uptime = system_time() / 1000000; // Make sure it is in seconds
	// All of the system information...
	system_info sys;
	get_system_info(&sys);
	// Comb through the struct for interesting things
	int32 NumberOfCpus = sys.cpu_count;
	int32 CpuClockSpeed = sys.cpu_clock_speed;
	CpuClockSpeed /= 1000000;
	cpu_type CpuType_t = sys.cpu_type;
	char CpuType[24];
	switch(CpuType_t)
	{
		case B_CPU_PPC_601:
			strcpy(CpuType, "PPC 601");
			break;
		case B_CPU_PPC_603:
			strcpy(CpuType, "PPC 603");
			break;
		case B_CPU_PPC_603e:
			strcpy(CpuType, "PPC 603e");
			break;
		case B_CPU_PPC_604:
			strcpy(CpuType, "PPC 604");
			break;
		case B_CPU_PPC_604e:
			strcpy(CpuType, "PPC 604e");
			break;
		case B_CPU_PPC_686:
			strcpy(CpuType, "PPC 686");
			break;
		case B_CPU_AMD_29K:
			strcpy(CpuType, "AMD 29K");
			break;
		case B_CPU_X86:
			strcpy(CpuType, "Intel");
			break;
		case B_CPU_MC6502:
			strcpy(CpuType, "MC6502");
			break;
		case B_CPU_Z80:
			strcpy(CpuType, "z80");
			break;
		case B_CPU_ALPHA:
			strcpy(CpuType, "DEC Alpha");
			break;
		case B_CPU_MIPS:
			strcpy(CpuType, "MIPS");
			break;
		case B_CPU_HPPA:
			strcpy(CpuType, "HPPA");
			break;
		case B_CPU_M68K:
			strcpy(CpuType, "Motorola 68k");
			break;
		case B_CPU_ARM:
			strcpy(CpuType, "(Strong)ARM");
			break;
		case B_CPU_SH:
			strcpy(CpuType, "SH");
			break;
		case B_CPU_SPARC:
			strcpy(CpuType, "Sun SPARC");
			break;
		case B_CPU_PPC_750:
			strcpy(CpuType, "Apple Power Macintosh G3");
			break;
		case B_CPU_INTEL_X86:
			strcpy(CpuType, "Intel");
			break;
		case B_CPU_INTEL_PENTIUM:
			strcpy(CpuType, "Intel Pentium");
			break;
		case B_CPU_INTEL_PENTIUM75:
			strcpy(CpuType, "Intel Pentium 75");
			break;
		case B_CPU_INTEL_PENTIUM_486_OVERDRIVE:
			strcpy(CpuType, "Intel 486-Overdrive");
			break;
		case B_CPU_INTEL_PENTIUM_MMX:
			strcpy(CpuType, "Intel Pentium with MMX");
			break;
		case B_CPU_INTEL_PENTIUM_MMX_MODEL_8:
			strcpy(CpuType, "Intel Pentium with MMX");
			break;
		case B_CPU_INTEL_PENTIUM75_486_OVERDRIVE:
			strcpy(CpuType, "Intel Pentium 75 486 Overdrive (What?)");
			break;
		case B_CPU_INTEL_PENTIUM_PRO:
			strcpy(CpuType, "Intel Pentium Pro");
			break;
		case B_CPU_INTEL_PENTIUM_II:
			strcpy(CpuType, "Intel Pentium II");
			break;
		case B_CPU_INTEL_PENTIUM_II_MODEL_5:
			strcpy(CpuType, "Intel Pentium II Model 5");
			break;
		case B_CPU_INTEL_CELERON:
			strcpy(CpuType, "Intel Celeron");
			break;
		case B_CPU_INTEL_PENTIUM_III:
			strcpy(CpuType, "Intel Pentium III");
			break;
		case B_CPU_AMD_X86:
			strcpy(CpuType, "AMD x86");
			break;
		case B_CPU_AMD_K5_MODEL0:
			strcpy(CpuType, "AMD K5 Model 0");
			break;
		case B_CPU_AMD_K5_MODEL1:
			strcpy(CpuType, "AMD K5 Model 1");
			break;
		case B_CPU_AMD_K5_MODEL2:
			strcpy(CpuType, "AMD K5 Model 2");
			break;
		case B_CPU_AMD_K5_MODEL3:
			strcpy(CpuType, "AMD K5 Model 3");
			break;
		case B_CPU_AMD_K6_MODEL6:
			strcpy(CpuType, "AMD K6 Model 6");
			break;
		case B_CPU_AMD_K6_MODEL7:
			strcpy(CpuType, "AMD K6 Model 7");
			break;
		case B_CPU_AMD_K6_MODEL8:
			strcpy(CpuType, "AMD K6 Model 8");
			break;
		case B_CPU_AMD_K6_III:
			strcpy(CpuType, "AMD K6-3");
			break;
		case B_CPU_CYRIX_X86:
			strcpy(CpuType, "Cyrix x86");
			break;
		case B_CPU_CYRIX_GXm:
			strcpy(CpuType, "Cyrix GXm");
			break;
		case B_CPU_CYRIX_6x86MX:
			strcpy(CpuType, "Cyrix 6x86MX");
			break;
		case B_CPU_IDT_X86:
			strcpy(CpuType, "IDT x86");
			break;
		case B_CPU_IDT_WINCHIP_C6:
			strcpy(CpuType, "IDT WinChip C6");
			break;
		case B_CPU_IDT_WINCHIP_2:
			strcpy(CpuType, "IDT WinChip 2");
			break;
	};
	
	platform_type PlatformType_t = sys.platform_type;
	char PlatformType[32];
	switch(PlatformType_t)
	{
		case B_BEBOX_PLATFORM:
			strcpy(PlatformType, "BeBox");
			break;
		case B_MAC_PLATFORM:
			strcpy(PlatformType, "Apple Macintosh or Macintosh-Clone");
			break;
		case B_AT_CLONE_PLATFORM:
			strcpy(PlatformType, "IBM PC/AT or Clone");
			break;
		case B_ENIAC_PLATFORM:
			strcpy(PlatformType, "ENIAC Maniac");
			break;
		case B_APPLE_II_PLATFORM:
			strcpy(PlatformType, "Apple ][");
			break;
		case B_CRAY_PLATFORM:
			strcpy(PlatformType, "CRAY Supercomputer");
			break;
		case B_LISA_PLATFORM:
			strcpy(PlatformType, "Apple Lisa or Macintosh XL");
			break;
		case B_TI_994A_PLATFORM:
			strcpy(PlatformType, "TI 994A");
			break;
		case B_TIMEX_SINCLAIR_PLATFORM:
			strcpy(PlatformType, "Timex Sinclair");
			break;
		case B_ORAC_1_PLATFORM:
			strcpy(PlatformType, "Orac(le?) 1");
			break;
		case B_HAL_PLATFORM:
			strcpy(PlatformType, "HAL9000.  Watch out.");
			break;
		case B_BESM_6_PLATFORM:
			strcpy(PlatformType, "Besm 6");
			break;
		case B_MK_61_PLATFORM:
			strcpy(PlatformType, "MK61");
			break;
		case B_NINTENDO_64_PLATFORM:
			strcpy(PlatformType, "Nintendo 64.  Dig it.");
			break;
	};
	
	int64 KernelVersion = sys.kernel_version;
	char *KernelBuildDate = sys.kernel_build_date;
	char *KernelBuildTime = sys.kernel_build_time;
	char *KernelName = sys.kernel_name;
	
	// Slice and dice it and put it into the view
	/* We have these variables at our disposal:
		char *IsComputerOn
		char *IsComputerOnFire
		int32 Uptime
		int32 NumberOfCpus
		int32 CpuClockSpeed
		char *CpuType
		char *PlatformType
		int64 KernelVersion
		char *KernelBuildDate
		char *KernelBuildTime
		char *KernelName
	*/
	
	// Write these to the screen
	char buf[64];
	SIView::info1->SetText(IsComputerOn);
	info2->SetText(IsComputerOnFire);
	sprintf(buf, "Uptime (seconds): %i", (int)Uptime);
	info3->SetText(buf);
	sprintf(buf, "Number of CPUs: %i", (int)NumberOfCpus);
	info4->SetText(buf);
	sprintf(buf, "Approx. CPU Clock Speed: %i", (int)CpuClockSpeed);
	info5->SetText(buf);
	sprintf(buf, "CPU Type: %s", CpuType);
	info6->SetText(buf);
	sprintf(buf, "Platform Type: %s", PlatformType);
	info7->SetText(buf);
	sprintf(buf, "Kernel Version: %i", (int)KernelVersion);
	info8->SetText(buf);
	sprintf(buf, "Kernel Build Time: %s %s", KernelBuildDate, KernelBuildTime);
	info9->SetText(buf);
	sprintf(buf, "Kernel Name: %s", KernelName);
	info10->SetText(buf);
	
	// Phew! We're done.  That was quite a bit of typing.
};

//------------- SIWindow -------------//
#include <Window.h>

class SIWindow:public BWindow
{
public:
	// Constructor
	SIWindow(void);
	// Destructor
	~SIWindow(void);
	
	virtual void MessageReceived(BMessage*);
	virtual bool QuitRequested(void);
private:
	SIView *view;
};

//------------- SIWindow Constructor -------------//
SIWindow::SIWindow(void):
	BWindow(
		/* BRect frame */ BRect(50.0, 50.0, 350.0, 250.0),
		/* const char *title */ "System Info 1.0",
		/* window_type type */ B_TITLED_WINDOW,
		/* uint32 flags */ B_NOT_RESIZABLE | B_ASYNCHRONOUS_CONTROLS | B_NOT_ZOOMABLE)
{
	// Add the SIView
	view = new SIView();
	AddChild(view);
};
		
//------------- SIWindow Destructor -------------//
SIWindow::~SIWindow(void)
{
	// Do nothing
};

//------------- SIWindow MessageReceived(BMessage *) -------------//
#include <Application.h>

void
SIWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case SI_OK_CLICKED:
			be_app->Lock();
			be_app->Quit();
			be_app->Unlock();
			break;
		default:
			BWindow::MessageReceived(msg);
			break;
	};
};

//------------- SIWindow QuitRequested(void) -------------//
bool
SIWindow::QuitRequested(void)
{
	// Tell ourselves to quit
	be_app->PostMessage(B_QUIT_REQUESTED);
	// Tell the caller that we're ready to quit
	return(true);
};

//------------- SIApplication -------------//
class SIApplication:public BApplication
{
public:
	// Constructor
	SIApplication(void);
	// Destructor
	~SIApplication(void);
	
	virtual void ReadyToRun(void);
};

//------------- SIApplication Constructor -------------//
SIApplication::SIApplication(void):
	BApplication("application/x-vnd.brianluft-sysinfo")
{
	// Do nothing
};

//------------- SIApplication Destructor -------------//
SIApplication::~SIApplication(void)
{
	// Do nothing
};

//------------- SIApplication::ReadyToRun -------------//
void
SIApplication::ReadyToRun(void)
{
	// Set up the window
	SIWindow *window = new SIWindow();
	// Show window
	window->Show();
};

//------------- main -------------//
int
main()
{
	// Connect to the app_server
	SIApplication *myapp = new SIApplication();
	// Run the application
	myapp->Run();
	// Close when we're done
	delete myapp;
	return(0);
};
	